function [ ] = Transformation(image1, image2, finalcore, corner1)

[sizey, sizex, sizez] = size(image1);
count = 0;
sxx = 0;
sxy = 0;
sxz = 0;
syx = 0;
syy = 0;
syz = 0;
szx = 0;
szy = 0;
szz = 0;
rlbarx = 0;
rlbary = 0;
rrbarx = 0;
rrbary = 0;
finalcoredash = zeros(sizey,sizex,4);
N = zeros(4,4);

for i = 1:sizey
    for j = 1:sizex
        if corner1(i,j) == 1
            rlbarx = rlbarx + j;
            rlbary = rlbary + i;
            rrbarx = rrbarx + finalcore(i,j,1);
            rrbary = rrbary + finalcore(i,j,2);
            count = count + 1;
        end;
    end;
end;

rlbarx = rlbarx/count;
rlbary = rlbary/count;
rrbarx = rrbarx/count;
rrbary = rrbary/count;

for i = 1:sizey
    for j = 1:sizex
        if corner1(i,j) == 1
            finalcoredash(i,j,1) = i - rlbarx;
            finalcoredash(i,j,2) = j - rlbary;
            finalcoredash(i,j,3) = finalcore(i,j,1) - rrbarx;
            finalcoredash(i,j,4) = finalcore(i,j,2) - rrbary;
        end;
    end;
end;

for i = 1:sizey
    for j = 1:sizex
        if corner1(i,j) == 1
            sxx = sxx + (finalcoredash(i,j,1) * finalcoredash(i,j,3));
            sxy = sxy + (finalcoredash(i,j,1) * finalcoredash(i,j,4));
            syx = syx + (finalcoredash(i,j,2) * finalcoredash(i,j,3));
            syy = syy + (finalcoredash(i,j,2) * finalcoredash(i,j,4));
        end;
    end;
end;

N(1,1) = sxx + syy + szz;
N(1,2) = syz - szy;
N(1,3) = szx - sxz;
N(1,4) = sxy - sxz;
N(2,1) = syz - szy;
N(2,2) = sxx - syy - szz;
N(2,3) = sxy + syx;
N(2,4) = szx + sxz;
N(3,1) = szx - sxz;
N(3,2) = sxy + syx;
N(3,3) = -sxx + syy - szz;
N(3,4) = syz + szy;
N(4,1) = sxy - syz;
N(4,2) = szx + sxz;
N(4,3) = syz + szy;
N(4,4) = -sxx - syy - szz;

Eigen = eig(N);
Eigen = max(Eigen);

I = [1 0 0; 0 1 0; 0 0 1];
cofac = zeros(4,4);
cofactrans = zeros(4,4);

LambdaI = Eigen * I;
N1 = N-LambdaI;


temp = N1(2:4,2:4); %%%%%%cofac(1,1)
temp = det(temp);
cofac(1,1) = temp;

for i = 1:3
    temp(i,1) = N1(i+1,1);   %%%%%%%%%%cofac(1,2)
end;
temp(1:3,2:3) = N1(2:4,3:4); 
temp = det(temp);
cofac(1,2) = temp;

temp(1:3,1:2) = N1(2:4,1:2); %%%%%%%%cofac(1,3)
for i = 1:3
    temp(i,3) = N1(i+1,4);
end;
temp = det(temp);
cofac(1,3) = temp;
        
temp = N1(2:4,1:3); %%%%%%%%cofac(1,4)
temp = det(temp);
cofac(1,4) = temp;

 %%%%%%%%%%%%%%%%%%%%%%%%%

 for i = 1:3
     temp(1,i) = N1(1,i+1); %%%%%%cofac(2,1)
 end;
temp(2:3,1:3) = N1(3:4,2:4);
temp = det(temp);
cofac(2,1) = temp;

temp(1,1) = N1(1,1);        %%%%%%%%%%cofac(2,2)
temp(2,1) = N1(3,1);
temp(3,1) = N1(4,1);
temp(1,2) = N1(1,3);
temp(1,3) = N1(1,4);
temp(2:3,2:3) = N1(3:4,3:4);
temp = det(temp);
cofac(2,2) = temp;

temp(1,1) = N1(1,1); %%%%%%%%%%%%%%cofac(2,3)
temp(1,2) = N1(1,2);
temp(1,3) = N1(1,4);
temp(2:3,1:2) = N1(3:4,1:2);
temp(2,3) = N1(3,4);
temp(3,3) = N1(4,4);
temp = det(temp);
cofac(2,3) = temp;
        
for i = 1:3
    temp(1,i) = N1(1,i); %%%%%%%%cofac(2,4)
end;
temp(2:3,1:3) = N1(3:4,1:3);
temp = det(temp);
cofac(2,4) = temp;



temp(1:2,1:3) = N1(1:2,2:4); %%%%%%cofac(3,1)
for i = 1:3
    temp(3,i) = N1(4,i+1);
end;
temp = det(temp);
cofac(3,1) = temp;


temp(1,1) = N1(1,1); %%%%%%% cofac(3,2)
temp(2,1) = N1(2,1);
temp(3,1) = N1(4,1);
temp(1:2,2:3) = N1(1:2,3:4);
temp(3,2) = N1(4,3);
temp(3,3) = N1(4,4);
temp = det(temp);
cofac(3,2) = temp;

temp(1:2,1:2) = N1(1:2,1:2); %%%%%%%%cofac(3,3)
temp(1,3) = N1(1,4);
temp(2,3) = N1(2,4);
temp(3,1) = N1(4,1);
temp(3,2) = N1(4,2);
temp(3,3) = N1(4,4);
temp = det(temp);
cofac(3,3) = temp;
        
temp(1:2,1:3) = N1(1:2,1:3); %%%%%%%%cofac(3,4)
for i = 1:3
    temp(3,i) = N1(4,i);
end;
temp = det(temp);
cofac(3,4) = temp;




temp = N1(1:3,2:4); %%%%%%cofac(4,1)
temp = det(temp);
cofac(4,1) = temp;

for i = 1:3
    temp(i,1) = N1(i,1);   %%%%%%%%%%cofac(4,2)
end;
temp(1:3,2:3) = N1(1:3,3:4); 
temp = det(temp);
cofac(4,2) = temp;

temp(1:3,1:2) = N1(1:3,1:2); %%%%%%%%cofac(4,3)
for i = 1:3
    temp(i,3) = N1(i,4);
end;
temp = det(temp);
cofac(4,3) = temp;
        
temp = N1(1:3,1:3); %%%%%%%%cofac(4,4)
temp = det(temp);
cofac(4,4) = temp; 

cofactrans = (cofac)';

