image1 = imread('square1.jpg');
image2 = imread('square2.jpg');
% Function to determine no. of components in an image

image1 = double(image1);
image2 = double(image2);

noc = 3;

%corner_main.m
%ResponseFunction.m
%cornerDetectarray.m
%cornerDetect.m %%%%%%%%%%%%% for RGB values
%cornerDetectOld-8-7.m for B/W images !!!
%corelate does the corelation
%Fhii calculates std deviation
%Inbar calculates average over a neighbourhood
%callsotm calls the sotm function and gives the m2 for coressponding m1
%sotm calculates the strength of match for single m2 coressponding to m1


[sizey,sizex,noc] = size(image1);
disp(sizey)
disp(sizex)
disp(noc)
R1 = zeros(sizey,sizex,noc);
R2 = zeros(sizey,sizex,noc);
%S = zeros(sizey,sizex);
for h = 1:noc
    disp('Main Iteration Number')
    disp(h)
    R1(:,:,h) = ResponseFunction(image1(:,:,h));
 %   R(:,:,h) = S(:,:); 
end;

for h = 1:noc
    R2(:,:,h) = ResponseFunction(image2(:,:,h));
end;

[corner1] = cornerDetectarray(R1,noc,sizey,sizex);
[corner2] = cornerDetectarray(R2,noc,sizey,sizex);

[coar1 coar2] = corelate(corner1, corner2, image1, image2,noc);
%%%%%%%%%%%%%%%% coar1 contains the corelation scores %%%%%%%%%%%%%%%% 
%%%%%%%%%%%%%%%% coar2 contains m2 coressponding to score in coar1 %%%%%%%%%%%%%%% %%%%%%%%%%%%%%

[finalcore]   = callsotm(image1, image2, coar1, coar2, corner1, noc);

%%%%%%%%%%%%% finalcore contains m2 for each coressponding m1 %%%%%%%%%%%%% %%%%%%%%%%%%%%

%%%%%%%%%%%%%% NOTES %%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%  call corner detection for every image %%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%% then call for the corelation fn. corelate for every 2
%%%%%%%%%%%%%%%%%%% images to find their scores and set of matching points %%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%% then call the relaxation fn. sotm to find the unique
%%%%%%%%%%%%%%%%%%% match for each pixel %%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%% Do this symmetrically........needs to be thought abt.
%%%%%%%%%%%%%%%%%%% %%%%%%%%%%%%%%%%%%
