function [strengthOfMatch] = sotm(image1,image2,i,j,p,q,noc)
corelateScore = 0;
[sizey,sizex,sizez] = size(image1);
neighbour1 = zeros((sizex/4)+15,(sizex/4)+15,noc);
neighbour2 = zeros((sizex/4)+15,(sizex/4)+15,noc);

c = i-(sizex/8)-7;
d = j-(sizex/8)-7;

for m = 1:(sizex/4 + 15)
    for n = 1:(sizex/4 + 15)
        for h = 1:noc
            if c > 0 & d > 0 & c < sizey & d < sizex
               neighbour1(m,n,h) = image1(c,d,h);
           end;
        end;
        d = d+1;
    end;
    c = c+1;
    d = j-(sizex/8)-7;
end;

c = p-(sizex/8)-7;
d = q-(sizex/8)-7;

for m = 1:(sizex/4 + 15)
    for n = 1:(sizex/4 + 15)
        for h = 1:noc
            if c > 0 & d > 0 & c < sizey & d < sizex
               neighbour2(m,n,h) = image2(c,d,h);
           end;
        end;
        d = d+1;
    end;
    c = c+1;
    d = q-(sizex/8)-7;
end;

n = 7;
m = 7;

for c = 8:(sizex/4 + 8)
    for d = 8:(sizex/4 + 8)
        for h = 1:noc
            
            scoretmp = zeros(sizex/4 + 1, sizex/4 + 1);
            u1 = c;
            v1 = d;
            
            I1bar = Inbar(n,m,u1,v1,neighbour1(:,:,h));
            Fhi1  = Fhii(n,m,u1,v1,neighbour(:,:,h));
            dist1 = sqrt(((i-c)^2)+((j-d)^2));
            
            a = 1;
            b = 1;
            
            for e = 8:(sizex/4 + 8)
                for f = 8:(sizex/4 + 8)
                    I2bar = Inbar(n,m,e,f,neighbour2(:,:,h));
                    dist2(a,b) = sqrt(((p-e)^2)+((q-f)^2));
                    for y = -n:n
                        for x = -m:m
                            scoretmp(a,b) = scoretmp(a,b) + ((neighbour1(u1+y,v1+x,h) - I1bar)*(neighbour2(e+y,f+x,h) - I2bar));
                        end;
                    end;
                    Fhi2 = Fhii(n,m,e,f,neighbour(:,:,h));
                    scoretmp(a,b) = scoretmp(a,b)./((2*n + 1)*(2*m + 1)*sqrt(((Fhi1)^2)*((Fhi2)^2)));
                    b = b+1;
                end;
                a = a+1;
                b=1;
            end;
            score(:,:,h) = scoretmp(:,:);
        end;
        
        for e = 1:(sizex/4 + 1)
            for f = 1:(sizex/4 + 1)
                neighcore1(e,f) = max(score(e,f,:));
            end;
        end;
        
        dist = (dist2 + dist1)./2;
        r    = (abs(dist1 - dist2))./dist; 
        
        for e = 1:(sizex/4 + 1)
            for f = 1:(sizex/4 + 1)
                if neighcore1(e,f)>=0.8 & r(e,f)<0.3
                    del(e,f) = -exp(r/0.3);
                else
                    del(e,f) = 0;
                end;
            end;
        end;
        
        Total = (neighcore1).*(del);
        Total = (Total)./(1 + dist);
        corelateScore = corelateScore + max(max(Total));
    end;
end;

StrengthOfMatch = cij * corelateScore;
return;

                    