%%%%%%%% Assumptions %%%%%%%%%%%
% 1> Images are gray scale images
% 2> Images are of same size
% 3> Currently designed for 2 images with significant overlap
% 4> Finding corresponding poins in both images is done manually


image1 = imread('./pictures/mosaic_images/lab1.jpg');  
image2 = imread('./pictures/mosaic_images/lab2.jpg');      

 %figure;
 %imshow(image1);

 %figure;
 %imshow(image2);

image1 = im2double(image1);
image2 = im2double(image2);

Point1(1,1) = 257;  %% x1             %%%%%%%%%% STEP 1 -- Computing 4 corresponding points in both the images
Point1(2,1) = 120;  %% y1

Point1(1,2) = 394;  %% x2
Point1(2,2) = 242;  %% y2

Point1(1,3) = 560;  %% x3
Point1(2,3) = 137;  %% y3

Point1(1,4) = 608;  %% x4   
Point1(2,4) = 404;  %% y4

Point1(1,5) = 268;  %% x5   
Point1(2,5) = 38;   %% y5

Point1(1,6) = 181;  %% x6   
Point1(2,6) = 305;  %% y6

Point1(1,7) = 272;  %% x7   
Point1(2,7) = 150;  %% y7

Point1(1,8) = 314;  %% x8   
Point1(2,8) = 118;  %% y8

Point1(1,9) = 420;  %% x9   
Point1(2,9) = 33;  %% y9

Point1(1,10) = 574;  %% x10  
Point1(2,10) = 451;  %% y10

Point1(1,11) = 200;  %% x11   
Point1(2,11) = 323;  %% y11

Point1(1,12) = 179;  %% x12  
Point1(2,12) = 238;  %% y12

Point1(1,13) = 395;  %% x13   
Point1(2,13) = 371;  %% y13

Point1(1,14) = 560;  %% x14   
Point1(2,14) = 59;  %% y14

Point1(1,15) = 603;  %% x15   
Point1(2,15) = 290;  %% y15

Point1(1,16) = 630;  %% x16   
Point1(2,16) = 222;  %% y16

Point1(1,17) = 303;  %% x17            
Point1(2,17) = 38;  %% y17

Point1(1,18) = 303;  %% x18
Point1(2,18) = 76;  %% y18

Point1(1,19) = 268;  %% x19
Point1(2,19) = 77;  %% y19

Point1(1,20) = 272;  %% x20   
Point1(2,20) = 186;  %% y20

Point1(1,21) = 271;  %% x21   
Point1(2,21) = 217;   %% y21

Point1(1,22) = 290;  %% x22   
Point1(2,22) = 236;  %% y22

Point1(1,23) = 466;  %% x23   
Point1(2,23) = 261;  %% y23

Point1(1,24) = 497;  %% x24   
Point1(2,24) = 437;  %% y24

Point1(1,25) = 615;  %% x25   
Point1(2,25) = 396;  %% y25

Point1(1,26) = 241;  %% x26  
Point1(2,26) = 331;  %% y26

Point1(1,27) = 563;  %% x27   
Point1(2,27) = 36;  %% y27

Point1(1,28) = 507;  %% x28  
Point1(2,28) = 62;  %% y28

Point1(1,29) = 495;  %% x29   
Point1(2,29) = 194;  %% y29

Point1(1,30) = 627;  %% x30   
Point1(2,30) = 139;  %% y30

Point1(1,31) = 636;  %% x31   
Point1(2,31) = 294;  %% y31

Point1(1,32) = 625;  %% x32   
Point1(2,32) = 233;  %% y32




%%%------------------------------------------------------------------------
%%%------------------------------------------------------------------------

Point2(1,1) = 109;  %% x1'
Point2(2,1) = 131;  %% y1'

Point2(1,2) = 240;  %% x2'
Point2(2,2) = 251;  %% y2'

Point2(1,3) = 414;  %% x3'
Point2(2,3) = 145;  %% y3'

Point2(1,4) = 453;  %% x4'
Point2(2,4) = 401;  %% y4'

Point2(1,5) = 120;  %% x5'
Point2(2,5) = 46;   %% y5'

Point2(1,6) = 27;   %% x6'
Point2(2,6) = 323;  %% y6'

Point2(1,7) = 124;  %% x7'   
Point2(2,7) = 160;  %% y7'

Point2(1,8) = 167;  %% x8'   
Point2(2,8) = 126;  %% y8'

Point2(1,9) = 274;  %% x9'   
Point2(2,9) = 41;  %% y9'

Point2(1,10) = 413;  %% x10'  
Point2(2,10) = 448;  %% y10'

Point2(1,11) = 52;  %% x11'  
Point2(2,11) = 340;  %% y11'

Point2(1,12) = 30;  %% x12' 
Point2(2,12) = 252;  %% y12'

Point2(1,13) = 243;  %% x13'  
Point2(2,13) = 378;  %% y13'

Point2(1,14) = 411;  %% x14'  
Point2(2,14) = 68;  %% y14'

Point2(1,15) = 452;  %% x15'  
Point2(2,15) = 291;  %% y15'

Point2(1,16) = 481;  %% x16'  
Point2(2,16) = 223;  %% y16'

Point2(1,17) = 156;  %% x17'            
Point2(2,17) = 47;  %% y17'

Point2(1,18) = 156;  %% x18'
Point2(2,18) = 84;  %% y18'

Point2(1,19) = 121;  %% x19'
Point2(2,19) = 86;  %% y19'

Point2(1,20) = 126;  %% x20'  
Point2(2,20) = 198;  %% y20'

Point2(1,21) = 125;   %% x21'   
Point2(2,21) = 229;   %% y21'

Point2(1,22) = 145;  %% x22' 
Point2(2,22) = 248;  %% y22'

Point2(1,23) = 313;  %% x23'  
Point2(2,23) = 268;  %% y23'

Point2(1,24) = 338;  %% x24'  
Point2(2,24) = 441;  %% y24'

Point2(1,25) = 461;  %% x25'  
Point2(2,25) = 393;  %% y25'

Point2(1,26) = 96;  %% x26' 
Point2(2,26) = 346;  %% y26'

Point2(1,27) = 412;  %% x27'  
Point2(2,27) = 46;  %% y27'

Point2(1,28) = 360;  %% x28' 
Point2(2,28) = 71;  %% y28'

Point2(1,29) = 350;  %% x29'  
Point2(2,29) = 202;  %% y29'

Point2(1,30) = 477;  %% x30'  
Point2(2,30) = 146;  %% y30'

Point2(1,31) = 483;  %% x31'  
Point2(2,31) = 294;  %% y31'

Point2(1,32) = 477;  %% x32'  
Point2(2,32) = 236;  %% y32'




%%%------------------------------------------------------------------------
%%%------------------------------------------------------------------------

[Workspace] = imagemosaic(Point1,Point2,image1,image2);

        
 Workspace(:,:,1) = medfilt2(Workspace(:,:,1),[5 5]);
 Workspace(:,:,2) = medfilt2(Workspace(:,:,2),[5 5]);
 Workspace(:,:,3) = medfilt2(Workspace(:,:,3),[5 5]);
 imwrite(Workspace,'mosaiced.jpg');
 im = imread('mosaiced.jpg');
 figure;
 imshow(im);
 
 image3 = imread('./pictures/mosaic_images/lab3.jpg'); 
 image3 = im2double(image3);


 
Point3(1,1) = 268;  %% x1             %%%%%%%%%% STEP 1 -- Computing 4 corresponding points in both the images
Point3(2,1) = 38;  %% y1

Point3(1,2) = 302;  %% x2
Point3(2,2) = 38;  %% y2

Point3(1,3) = 269;  %% x3
Point3(2,3) = 76;  %% y3

Point3(1,4) = 304;  %% x4   
Point3(2,4) = 76;  %% y4

Point3(1,5) = 7;  %% x5   
Point3(2,5) = 448;   %% y5

Point3(1,6) = 6;  %% x6   
Point3(2,6) = 424;  %% y6

Point3(1,7) = 22;  %% x7   
Point3(2,7) = 396;  %% y7

Point3(1,8) = 34;  %% x8   
Point3(2,8) = 404;  %% y8

Point3(1,9) = 10;  %% x9   
Point3(2,9) = 68;  %% y9

Point3(1,10) = 18;  %% x10  
Point3(2,10) = 74;  %% y10

Point3(1,11) = 68;  %% x11   
Point3(2,11) = 68;  %% y11

Point3(1,12) = 156;  %% x12  
Point3(2,12) = 76;  %% y12

Point3(1,13) = 156;  %% x13   
Point3(2,13) = 39;  %% y13

Point3(1,14) = 14;  %% x14   
Point3(2,14) = 47;  %% y14

Point3(1,15) = 268;  %% x15   
Point3(2,15) = 188;  %% y15

Point3(1,16) = 272;  %% x16   
Point3(2,16) = 217;  %% y16

Point3(1,17) = 303;  %% x17            
Point3(2,17) = 186;  %% y17

Point3(1,18) = 298;  %% x18
Point3(2,18) = 210;  %% y18

Point3(1,19) = 271;  %% x19
Point3(2,19) = 149;  %% y19

Point3(1,20) = 298;  %% x20   
Point3(2,20) = 150;  %% y20

Point3(1,21) = 240;  %% x21   
Point3(2,21) = 332;   %% y21

Point3(1,22) = 253;  %% x22   
Point3(2,22) = 292;  %% y22

Point3(1,23) = 291;  %% x23   
Point3(2,23) = 319;  %% y23

Point3(1,24) = 250;  %% x24   
Point3(2,24) = 313;  %% y24

Point3(1,25) = 148;  %% x25   
Point3(2,25) = 338;  %% y25

Point3(1,26) = 131;  %% x26  
Point3(2,26) = 362;  %% y26

Point3(1,27) = 103;  %% x27   
Point3(2,27) = 351;  %% y27

Point3(1,28) = 122;  %% x28  
Point3(2,28) = 352;  %% y28

Point3(1,29) = 144;  %% x29   
Point3(2,29) = 340;  %% y29

Point3(1,30) = 116;  %% x30   
Point3(2,30) = 340;  %% y30

Point3(1,31) = 4;  %% x31   
Point3(2,31) = 181;  %% y31

Point3(1,32) = 97;  %% x32   
Point3(2,32) = 139;  %% y32




%%%------------------------------------------------------------------------
%%%------------------------------------------------------------------------

Point4(1,1) = 566;  %% x1'
Point4(2,1) = 75;  %% y1'

Point4(1,2) = 604;  %% x2'
Point4(2,2) = 72;  %% y2'

Point4(1,3) = 568;  %% x3'
Point4(2,3) = 113;  %% y3'

Point4(1,4) = 605;  %% x4'
Point4(2,4) = 112;  %% y4'

Point4(1,5) = 317;  %% x5'
Point4(2,5) = 464;   %% y5'

Point4(1,6) = 316;   %% x6'
Point4(2,6) = 443;  %% y6'

Point4(1,7) = 332;  %% x7'   
Point4(2,7) = 418;  %% y7'

Point4(1,8) = 341;  %% x8'   
Point4(2,8) = 427;  %% y8'

Point4(1,9) = 322;  %% x9'   
Point4(2,9) = 110;  %% y9'

Point4(1,10) = 327;  %% x10'  
Point4(2,10) = 116;  %% y10'

Point4(1,11) = 372;  %% x11'  
Point4(2,11) = 108;  %% y11'

Point4(1,12) = 456;  %% x12' 
Point4(2,12) = 116;  %% y12'

Point4(1,13) = 454;  %% x13'  
Point4(2,13) = 78;  %% y13'

Point4(1,14) = 326;  %% x14'  
Point4(2,14) = 92;  %% y14'

Point4(1,15) = 568;  %% x15'  
Point4(2,15) = 228;  %% y15'

Point4(1,16) = 570;  %% x16'  
Point4(2,16) = 257;  %% y16'

Point4(1,17) = 604;  %% x17'            
Point4(2,17) = 227;  %% y17'

Point4(1,18) = 599;  %% x18'
Point4(2,18) = 252;  %% y18'

Point4(1,19) = 572;  %% x19'
Point4(2,19) = 188;  %% y19'

Point4(1,20) = 599;  %% x20'  
Point4(2,20) = 188;  %% y20'

Point4(1,21) = 532;   %% x21'   
Point4(2,21) = 373;   %% y21'

Point4(1,22) = 548;  %% x22' 
Point4(2,22) = 333;  %% y22'

Point4(1,23) = 588;  %% x23'  
Point4(2,23) = 364;  %% y23'

Point4(1,24) = 544;  %% x24'  
Point4(2,24) = 354;  %% y24'

Point4(1,25) = 449;  %% x25'  
Point4(2,25) = 374;  %% y25'

Point4(1,26) = 434;  %% x26' 
Point4(2,26) = 396;  %% y26'

Point4(1,27) = 405;  %% x27'  
Point4(2,27) = 382;  %% y27'

Point4(1,28) = 424;  %% x28' 
Point4(2,28) = 386;  %% y28'

Point4(1,29) = 446;  %% x29'  
Point4(2,29) = 375;  %% y29'

Point4(1,30) = 419;  %% x30'  
Point4(2,30) = 372;  %% y30'

Point4(1,31) = 312;  %% x31'  
Point4(2,31) = 215;  %% y31'

Point4(1,32) = 398;  %% x32'  
Point4(2,32) = 176;  %% y32'

%%%------------------------------------------------------------------------
%%%------------------------------------------------------------------------

[Workspace] = imagemosaic(Point4,Point3,image3,Workspace);

 Workspace(:,:,1) = medfilt2(Workspace(:,:,1),[5 5]);
 Workspace(:,:,2) = medfilt2(Workspace(:,:,2),[5 5]);
 Workspace(:,:,3) = medfilt2(Workspace(:,:,3),[5 5]);       
 imwrite(Workspace,'mosaiced.jpg');
 im = imread('mosaiced.jpg');
 figure;
 imshow(im);

 image5 = imread('./pictures/mosaic_images/lab5.jpg'); 
 image5 = im2double(image5);
 
%%%------------------------------------------------------------------------
%%%------------------------------------------------------------------------
 
 
Point3(1,1) = 566;  %% x1             %%%%%%%%%% STEP 1 -- Computing 4 corresponding points in both the images
Point3(2,1) = 227;  %% y1

Point3(1,2) = 570;  %% x2
Point3(2,2) = 257;  %% y2

Point3(1,3) = 606;  %% x3
Point3(2,3) = 227;  %% y3

Point3(1,4) = 601;  %% x4   
Point3(2,4) = 253;  %% y4

Point3(1,5) = 401;  %% x5   
Point3(2,5) = 381;   %% y5

Point3(1,6) = 356;  %% x6   
Point3(2,6) = 405;  %% y6

Point3(1,7) = 376;  %% x7   
Point3(2,7) = 430;  %% y7

Point3(1,8) = 431;  %% x8   
Point3(2,8) = 395;  %% y8

Point3(1,9) = 338;  %% x9   
Point3(2,9) = 453;  %% y9

Point3(1,10) = 305;  %% x10  
Point3(2,10) = 373;  %% y10

Point3(1,11) = 312;  %% x11   
Point3(2,11) = 215;  %% y11

Point3(1,12) = 305;  %% x12  
Point3(2,12) = 275;  %% y12

Point3(1,13) = 912;  %% x13   
Point3(2,13) = 281;  %% y13

Point3(1,14) = 860;  %% x14   
Point3(2,14) = 307;  %% y14

Point3(1,15) = 839;  %% x15   
Point3(2,15) = 277;  %% y15

Point3(1,16) = 810;  %% x16   
Point3(2,16) = 292;  %% y16

Point3(1,17) = 702;  %% x17            
Point3(2,17) = 379;  %% y17

Point3(1,18) = 717;  %% x18
Point3(2,18) = 469;  %% y18

Point3(1,19) = 699;  %% x19
Point3(2,19) = 417;  %% y19

Point3(1,20) = 929;  %% x20   
Point3(2,20) = 433;  %% y20

Point3(1,21) = 791;  %% x21   
Point3(2,21) = 217;   %% y21

Point3(1,22) = 791;  %% x22   
Point3(2,22) = 226;  %% y22

Point3(1,23) = 691;  %% x23   
Point3(2,23) = 215;  %% y23

Point3(1,24) = 691;  %% x24   
Point3(2,24) = 223;  %% y24

Point3(1,25) = 548;  %% x25   
Point3(2,25) = 339;  %% y25

Point3(1,26) = 553;  %% x26  
Point3(2,26) = 350;  %% y26

Point3(1,27) = 554;  %% x27   
Point3(2,27) = 287;  %% y27

Point3(1,28) = 523;  %% x28  
Point3(2,28) = 297;  %% y28

Point3(1,29) = 587;  %% x29   
Point3(2,29) = 280;  %% y29

Point3(1,30) = 475;  %% x30   
Point3(2,30) = 276;  %% y30

Point3(1,31) = 465;  %% x31   
Point3(2,31) = 209;  %% y31

Point3(1,32) = 702;  %% x32   
Point3(2,32) = 289;  %% y32




%%%------------------------------------------------------------------------
%%%------------------------------------------------------------------------

Point4(1,1) = 281;  %% x1'
Point4(2,1) = 38;  %% y1'

Point4(1,2) = 284;  %% x2'
Point4(2,2) = 68;  %% y2'

Point4(1,3) = 318;  %% x3'
Point4(2,3) = 38;  %% y3'

Point4(1,4) = 314;  %% x4'
Point4(2,4) = 64;  %% y4'

Point4(1,5) = 115;  %% x5'
Point4(2,5) = 200;   %% y5'

Point4(1,6) = 69;   %% x6'
Point4(2,6) = 228;  %% y6'

Point4(1,7) = 92;  %% x7'   
Point4(2,7) = 252;  %% y7'

Point4(1,8) = 148;  %% x8'   
Point4(2,8) = 212;  %% y8'

Point4(1,9) = 56;  %% x9'   
Point4(2,9) = 278;  %% y9'

Point4(1,10) = 12;  %% x10'  
Point4(2,10) = 202;  %% y10'

Point4(1,11) = 10;  %% x11'  
Point4(2,11) = 33;  %% y11'

Point4(1,12) = 12;  %% x12' 
Point4(2,12) = 101;  %% y12'

Point4(1,13) = 589;  %% x13'  
Point4(2,13) = 87;  %% y13'

Point4(1,14) = 544;  %% x14'  
Point4(2,14) = 111;  %% y14'

Point4(1,15) = 528;  %% x15'  
Point4(2,15) = 82;  %% y15'

Point4(1,16) = 506;  %% x16'  
Point4(2,16) = 96;  %% y16'

Point4(1,17) = 406;  %% x17'            
Point4(2,17) = 179;  %% y17'

Point4(1,18) = 418;  %% x18'
Point4(2,18) = 260;  %% y18'

Point4(1,19) = 404;  %% x19'
Point4(2,19) = 212;  %% y19'

Point4(1,20) = 593;  %% x20'  
Point4(2,20) = 221;  %% y20'

Point4(1,21) = 488;   %% x21'   
Point4(2,21) = 28;   %% y21'

Point4(1,22) = 487;  %% x22' 
Point4(2,22) = 36;  %% y22'

Point4(1,23) = 400;  %% x23'  
Point4(2,23) = 28;  %% y23'

Point4(1,24) = 400;  %% x24'  
Point4(2,24) = 36;  %% y24'

Point4(1,25) = 267;  %% x25'  
Point4(2,25) = 149;  %% y25'

Point4(1,26) = 270;  %% x26' 
Point4(2,26) = 160;  %% y26'

Point4(1,27) = 272;  %% x27'  
Point4(2,27) = 69;  %% y27'

Point4(1,28) = 240;  %% x28' 
Point4(2,28) = 110;  %% y28'

Point4(1,29) = 303;  %% x29'  
Point4(2,29) = 89;  %% y29'

Point4(1,30) = 192;  %% x30'  
Point4(2,30) = 90;  %% y30'

Point4(1,31) = 178;  %% x31'  
Point4(2,31) = 23;  %% y31'

Point4(1,32) = 406;  %% x32'  
Point4(2,32) = 95;  %% y32'

%%%------------------------------------------------------------------------
%%%------------------------------------------------------------------------

[Workspace] = imagemosaic(Point3,Point4,Workspace,image5);

 Workspace(:,:,1) = medfilt2(Workspace(:,:,1),[5 5]);
 Workspace(:,:,2) = medfilt2(Workspace(:,:,2),[5 5]);
 Workspace(:,:,3) = medfilt2(Workspace(:,:,3),[5 5]);         
 imwrite(Workspace,'mosaiced.jpg');
 im = imread('mosaiced.jpg');
 figure;
 imshow(im);
 
 
 image4 = imread('./pictures/mosaic_images/lab4.jpg'); 
 image4 = im2double(image4);
 
%%%------------------------------------------------------------------------
%%%------------------------------------------------------------------------
 
 
Point3(1,1) = 456;  %% x1             %%%%%%%%%% STEP 1 -- Computing 4 corresponding points in both the images
Point3(2,1) = 80;  %% y1

Point3(1,2) = 455;  %% x2
Point3(2,2) = 116;  %% y2

Point3(1,3) = 393;  %% x3
Point3(2,3) = 107;  %% y3

Point3(1,4) = 371;  %% x4   
Point3(2,4) = 108;  %% y4

Point3(1,5) = 328;  %% x5   
Point3(2,5) = 114;   %% y5

Point3(1,6) = 322;  %% x6   
Point3(2,6) = 84;  %% y6

Point3(1,7) = 321;  %% x7   
Point3(2,7) = 109;  %% y7

Point3(1,8) = 568;  %% x8   
Point3(2,8) = 73;  %% y8

Point3(1,9) = 567;  %% x9   
Point3(2,9) = 111;  %% y9

Point3(1,10) = 603;  %% x10  
Point3(2,10) = 111;  %% y10

Point3(1,11) = 603;  %% x11   
Point3(2,11) = 72;  %% y11

Point3(1,12) = 599;  %% x12  
Point3(2,12) = 187;  %% y12

Point3(1,13) = 599;  %% x13   
Point3(2,13) = 225;  %% y13

Point3(1,14) = 569;  %% x14   
Point3(2,14) = 225;  %% y14

Point3(1,15) = 569;  %% x15   
Point3(2,15) = 187;  %% y15

Point3(1,16) = 566;  %% x16   
Point3(2,16) = 226;  %% y16

Point3(1,17) = 605;  %% x17            
Point3(2,17) = 226;  %% y17

Point3(1,18) = 544;  %% x18
Point3(2,18) = 173;  %% y18

Point3(1,19) = 473;  %% x19
Point3(2,19) = 175;  %% y19

Point3(1,20) = 471;  %% x20   
Point3(2,20) = 238;  %% y20

Point3(1,21) = 384;  %% x21   
Point3(2,21) = 215;   %% y21

Point3(1,22) = 464;  %% x22   
Point3(2,22) = 275;  %% y22

Point3(1,23) = 345;  %% x23   
Point3(2,23) = 270;  %% y23

Point3(1,24) = 834;  %% x24   
Point3(2,24) = 94;  %% y24

Point3(1,25) = 744;  %% x25   
Point3(2,25) = 99;  %% y25

Point3(1,26) = 734;  %% x26  
Point3(2,26) = 64;  %% y26

Point3(1,27) = 897;  %% x27   
Point3(2,27) = 98;  %% y27

Point3(1,28) = 895;  %% x28  
Point3(2,28) = 65;  %% y28

Point3(1,29) = 986;  %% x29   
Point3(2,29) = 179;  %% y29

Point3(1,30) = 902;  %% x30   
Point3(2,30) = 176;  %% y30

Point3(1,31) = 909;  %% x31   
Point3(2,31) = 281;  %% y31

Point3(1,32) = 792;  %% x32   
Point3(2,32) = 217;  %% y32




%%%------------------------------------------------------------------------
%%%------------------------------------------------------------------------

Point4(1,1) = 154;  %% x1'
Point4(2,1) = 275;  %% y1'

Point4(1,2) = 153;  %% x2'
Point4(2,2) = 312;  %% y2'

Point4(1,3) = 90;  %% x3'
Point4(2,3) = 300;  %% y3'

Point4(1,4) = 66;  %% x4'
Point4(2,4) = 299;  %% y4'

Point4(1,5) = 18;  %% x5'
Point4(2,5) = 304;   %% y5'

Point4(1,6) = 16;   %% x6'
Point4(2,6) = 273;  %% y6'

Point4(1,7) = 12;  %% x7'   
Point4(2,7) = 297;  %% y7'

Point4(1,8) = 262;  %% x8'   
Point4(2,8) = 278;  %% y8'

Point4(1,9) = 261;  %% x9'   
Point4(2,9) = 314;  %% y9'

Point4(1,10) = 296;  %% x10'  
Point4(2,10) = 315;  %% y10'

Point4(1,11) = 297;  %% x11'  
Point4(2,11) = 279;  %% y11'

Point4(1,12) = 290;  %% x12' 
Point4(2,12) = 389;  %% y12'

Point4(1,13) = 290;  %% x13'  
Point4(2,13) = 427;  %% y13'

Point4(1,14) = 263;  %% x14'  
Point4(2,14) = 427;  %% y14'

Point4(1,15) = 263;  %% x15'  
Point4(2,15) = 389;  %% y15'

Point4(1,16) = 258;  %% x16'  
Point4(2,16) = 427;  %% y16'

Point4(1,17) = 295;  %% x17'            
Point4(2,17) = 427;  %% y17'

Point4(1,18) = 238;  %% x18'
Point4(2,18) = 373;  %% y18'

Point4(1,19) = 168;  %% x19'
Point4(2,19) = 373;  %% y19'

Point4(1,20) = 162;  %% x20'  
Point4(2,20) = 439;  %% y20'

Point4(1,21) = 72;   %% x21'   
Point4(2,21) = 413;   %% y21'

Point4(1,22) = 154;  %% x22' 
Point4(2,22) = 477;  %% y22'

Point4(1,23) = 15;  %% x23'  
Point4(2,23) = 476;  %% y23'

Point4(1,24) = 496;  %% x24'  
Point4(2,24) = 300;  %% y24'

Point4(1,25) = 420;  %% x25'  
Point4(2,25) = 304;  %% y25'

Point4(1,26) = 412;  %% x26' 
Point4(2,26) = 274;  %% y26'

Point4(1,27) = 546;  %% x27'  
Point4(2,27) = 303;  %% y27'

Point4(1,28) = 548;  %% x28' 
Point4(2,28) = 273;  %% y28'

Point4(1,29) = 620;  %% x29'  
Point4(2,29) = 371;  %% y29'

Point4(1,30) = 554;  %% x30'  
Point4(2,30) = 372;  %% y30'

Point4(1,31) = 567;  %% x31'  
Point4(2,31) = 468;  %% y31'

Point4(1,32) = 466;  %% x32'  
Point4(2,32) = 415;  %% y32'

%%%------------------------------------------------------------------------
%%%------------------------------------------------------------------------

[Workspace] = imagemosaic(Point4,Point3,image4,Workspace);

 Workspace(:,:,1) = medfilt2(Workspace(:,:,1),[5 5]);
 Workspace(:,:,2) = medfilt2(Workspace(:,:,2),[5 5]);
 Workspace(:,:,3) = medfilt2(Workspace(:,:,3),[5 5]);
 imwrite(Workspace,'mosaiced.jpg');
 im = imread('mosaiced.jpg');
 figure;
 imshow(im);
 
 
 
 
 